#!/bin/bash

sudo apt update
sudo apt install -y build-essential ninja-build meson cmake libnuma-dev libibverbs-dev librdmacm-dev pkg-config

sudo sysctl -w net.core.rmem_max=26214400
sudo sysctl -w net.core.wmem_max=26214400
sudo sysctl -w net.ipv4.tcp_mtu_probing=1
sudo sysctl -w net.ipv4.tcp_window_scaling=1
sudo sysctl -w vm.max_map_count=262144



# BoringSSLの取得
git clone https://boringssl.googlesource.com/boringssl
cd boringssl

# ビルドディレクトリ作成
mkdir build && cd build

# 最適化コンパイル
cmake -DCMAKE_POSITION_INDEPENDENT_CODE=TRUE \
      -DBORINGSSL_USE_SMALL=0 \
      -DBORINGSSL_ENABLE_PQC=1 \
      -DBORINGSSL_ENABLE_ASM=1 \
      -DBORINGSSL_ENABLE_FAST_TLS=1 \
      -DOPENSSL_SMALL=0 \
      -DEVP_MAXIMIZE_PERFORMANCE=1 \
      -DSSL_ENABLE_ASYNC=1 \
      -DBORINGSSL_ENABLE_OCB=1 \
      -DBORINGSSL_BYPASS_PUBKEY_CHECK=1 \
      -DSSL_OP_NO_TICKET=1 \
      -DSSL_OP_NO_QUERY_MTU=1 \
      -DSSL_OP_NO_COMPRESSION=1 \
      -DSSL_OP_NO_RENEGOTIATION=1 \
      -DSSL_OP_NO_CLIENT_CERTS=1 \
      -DSSL_OP_ENABLE_PARTIAL_WRITE=1 \
      -DEVP_CTRL_AEAD_SET_TAG=1 \
      -DEVP_CTRL_GCM_SET_IV_FIXED=1 \
      -DEVP_CIPH_FLAG_HARDWARE_ACCELERATED=1 

make -j$(nproc)

git clone https://github.com/DPDK/dpdk.git
cd dpdk
meson setup build
cd build
ninja
sudo ninja install

#!/bin/bash

gcc -O3 -march=znver4 -flto -fPIC -pthread -mavx2 -mprefer-vector-width=512 \
    -I/usr/local/include \
    -L/usr/local/lib -lssl -lcrypto \
    -ldpdk -libverbs -o https_client boringssl_v1.c
    
sudo dpdk-devbind --status
sudo modprobe vfio-pci
sudo dpdk-devbind --bind=vfio-pci <PCI_DEVICE_ID>

sudo ./https_client --log-level=8 --vdev="net_null"